## emoslib 4.3.7

=== CMakeLists.txt ===
################################################################################
# cmake options:
#   -DCMAKE_BUILD_TYPE=Debug|RelWithDebInfo|Release|Production
#   -DCMAKE_INSTALL_PREFIX=/path/to/install
#
#   -DCMAKE_C_COMPILER=gcc
#   -CMAKE_Fortran_COMPILER=gfortran
#
#   -DCMAKE_PREFIX_PATH=/path/to/jasper:/path/to/any/package/out/of/place
#   -DBUILD_SHARED_LIBS=OFF

cmake_minimum_required( VERSION 2.8.4 FATAL_ERROR )

project( libemos )

enable_language( Fortran )

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")

include( ecbuild_system NO_POLICY_SCOPE )

ecbuild_requires_macro_version( 1.9 )

ecbuild_add_option( FEATURE INSTALL_TABLES   DESCRIPTION "install BUFR/GRIBex/LSM tables"                                               DEFAULT ON )
ecbuild_add_option( FEATURE INSTALL_TOOLS    DESCRIPTION "install BUFR/GRIBex tools"                                                    DEFAULT ON )
ecbuild_add_option( FEATURE FORTRAN90        DESCRIPTION "enable tools which need Fortran 90 (only required for FC=pgf77)"              DEFAULT ON )
ecbuild_add_option( FEATURE SINGLE_PRECISION DESCRIPTION "enable single precision version of library (in addition to double precision)" DEFAULT ON )
ecbuild_add_option( FEATURE GRIBEX_ABORT     DESCRIPTION "abort execution on GRIBex calls"                                              DEFAULT ON )

ecbuild_add_option( FEATURE REQUIRE_FFTW     DESCRIPTION "require package: Fastest Fourier Transform in the West" DEFAULT ON )
ecbuild_add_option( FEATURE FFTW             DESCRIPTION "Fastest Fourier Transform in the West"                  DEFAULT ON REQUIRED_PACKAGES FFTW )
set_package_properties( FFTW PROPERTIES TYPE RECOMMENDED PURPOSE "allows interpolation of spectral to octahedral reduced Gaussian grid" )

ecbuild_add_option( FEATURE LIBEMOS_BUFRDC        DESCRIPTION "enable BUFR decoding functionality" DEFAULT ON )
ecbuild_add_option( FEATURE LIBEMOS_INTERPOLATION DESCRIPTION "enable interpolation functionality" DEFAULT ON )
ecbuild_add_option( FEATURE LIBEMOS_GRIBEX        DESCRIPTION "enable GRIBex functionality"        DEFAULT ON )
ecbuild_add_option( FEATURE LIBEMOS_TESTS_REGRESS DESCRIPTION "additional tests: regression"       DEFAULT OFF )


################################################################################
# compiler/linker flags

if( ${CMAKE_SYSTEM_NAME} MATCHES "Linux" )
  set( emos_special_system_def linux FOPEN64 )
elseif( ${CMAKE_SYSTEM_NAME} MATCHES "Darwin" )
  set( emos_special_system_def darwin )
endif()

get_filename_component(Fortran_COMPILER_NAME ${CMAKE_Fortran_COMPILER} NAME)

# double precision flags: only for d.p. Fortran-based targets (compiling & linking)
if(CMAKE_Fortran_COMPILER_ID MATCHES "GNU")
  set(emos_double_precision_flags "-fdefault-real-8 -fdefault-double-8")
elseif(CMAKE_Fortran_COMPILER_ID MATCHES "Intel")
  set(emos_double_precision_flags "-r8 -i4")
elseif(CMAKE_Fortran_COMPILER_ID MATCHES "PGI")
  set(emos_double_precision_flags "-r8 -i4")
elseif(CMAKE_Fortran_COMPILER_ID MATCHES "Cray")
  set(emos_double_precision_flags "-s integer32 -s real64")
else()
  set(emos_double_precision_flags "")
endif()

# build type flags
if(CMAKE_Fortran_COMPILER_ID MATCHES "GNU")
  ecbuild_add_fortran_flags("-ffixed-line-length-none -fcray-pointer -fno-second-underscore -Wuninitialized -Wunused-variable -DSHAREDMEMORY")
  ecbuild_add_fortran_flags("-O2 -mtune=native" BUILD RELEASE)
  ecbuild_add_fortran_flags("-O2 -mtune=native" BUILD RELWITHDEBINFO)
  ecbuild_add_fortran_flags("-g"                BUILD RELWITHDEBINFO)
  ecbuild_add_fortran_flags("-g"                BUILD DEBUG)
# ecbuild_remove_fortran_flags("-fcheck=bounds" BUILD DEBUG)
  set(emos_special_compiler_def "gfortran")
elseif(CMAKE_Fortran_COMPILER_ID MATCHES "Intel")
  ecbuild_add_fortran_flags("-DSHAREDMEMORY")
  ecbuild_add_fortran_flags("-f77rtl"    BUILD RELEASE)
  ecbuild_add_fortran_flags("-f77rtl -g" BUILD RELWITHDEBINFO)
  ecbuild_add_fortran_flags("-f77rtl -g" BUILD DEBUG)
  if(HAVE_LIBEMOS_GRIBEX)
    ecbuild_add_fortran_flags("-O1" BUILD RELEASE)         # otherwise breaks GRIBex second-order packing
    ecbuild_add_fortran_flags("-O1" BUILD RELWITHDEBINFO)  # otherwise breaks GRIBex second-order packing
    ecbuild_add_fortran_flags("-O0" BUILD DEBUG)
  else()
    ecbuild_add_fortran_flags("-O3" BUILD RELEASE)
    ecbuild_add_fortran_flags("-O2" BUILD RELWITHDEBINFO)
    ecbuild_add_fortran_flags("-O0" BUILD DEBUG)
  endif()
elseif(CMAKE_Fortran_COMPILER_ID MATCHES "PGI")
  ecbuild_add_fortran_flags("-fast -Kieee -Mvect=prefetch -noswitcherror -Mextend")
  ecbuild_add_fortran_flags("-O2"    BUILD RELEASE)
  ecbuild_add_fortran_flags("-g -O2" BUILD RELWITHDEBINFO)
  ecbuild_add_fortran_flags("-g"     BUILD DEBUG)
elseif(CMAKE_Fortran_COMPILER_ID MATCHES "Cray")
  ecbuild_add_fortran_flags("-ev -Wl,--as-needed -h PIC -emf -hflex_mp=conservative -hfp1 -hadd_paren -DSHAREDMEMORY")
  ecbuild_add_fortran_flags("-G2"       BUILD RELWITHDEBINFO)
  ecbuild_add_fortran_flags("-G0 -hfp0" BUILD DEBUG)
  ecbuild_add_c_flags("-Wl,--as-needed -h PIC -DSHAREDMEMORY")
else()
  message("No optimized Fortran compiler flags are known, we just try -O2...")
  ecbuild_add_fortran_flags("-O2"    BUILD RELEASE)
  ecbuild_add_fortran_flags("-O2 -g" BUILD RELWITHDEBINFO)
  ecbuild_add_fortran_flags("-O0 -g" BUILD DEBUG)
endif()


################################################################################
# extra packages and projects

ecbuild_use_package( PROJECT grib_api VERSION 1.14.3 REQUIRED )

ecbuild_declare_project()


################################################################################
# contents

# project export variables
set( LIBEMOS_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} )
set( LIBEMOS_LIBRARIES    emos ${GRIB_API_LIBRARIES} )

set_directory_properties(PROPERTIES COMPILE_DEFINITIONS "${GRIB_API_DEFINITIONS}" )

include_directories( ${LIBEMOS_INCLUDE_DIRS}  )
include_directories( ${GRIB_API_INCLUDE_DIRS} )
if( HAVE_FFTW )
  include_directories( ${FFTW_INCLUDES} )
elseif( HAVE_REQUIRE_FFTW )
  message( FATAL_ERROR "\nCannot build without FFTW support (support is required)!")
endif()

if( BUFR_TABLES_PATH )
  if( NOT IS_ABSOLUTE "${BUFR_TABLES_PATH}" )
    set( BUFR_TABLES_PATH "${CMAKE_INSTALL_PREFIX}/${BUFR_TABLES_PATH}" )
  endif()
else()
  set( BUFR_TABLES_PATH "${CMAKE_INSTALL_PREFIX}/${INSTALL_DATA_DIR}/tables/bufrtables" )
endif()
add_definitions( -DBUFR_TABLES_PATH="${BUFR_TABLES_PATH}" )
message( STATUS "BUFR_TABLES_PATH: ${BUFR_TABLES_PATH}" )

# get_directory_property( LIBEMOS_DEFINITIONS COMPILE_DEFINITIONS ) # don't export libemos definitions

# config header
ecbuild_generate_config_headers( DESTINATION ${INSTALL_INCLUDE_DIR}/libemos )

configure_file( libemos_config.h.in  libemos_config.h  @ONLY )
configure_file( libemos_version.h.in libemos_version.h @ONLY )
configure_file( libemos_version.c.in libemos_version.c @ONLY )

install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/libemos_config.h
  ${CMAKE_CURRENT_BINARY_DIR}/libemos_version.h
  DESTINATION
  ${INSTALL_INCLUDE_DIR}/libemos )


################################################################################
# sources

if( HAVE_LIBEMOS_INTERPOLATION AND NOT HAVE_LIBEMOS_GRIBEX )
  message( FATAL_ERROR "\nCannot build libemos interpolation without GRIBex support!\nPlease pass option to cmake -DENABLE_LIBEMOS_GRIBEX=ON")
endif()

add_subdirectory( common )
add_subdirectory( pbio )

if( HAVE_LIBEMOS_GRIBEX )
  add_subdirectory( gribex )
endif()

if( HAVE_LIBEMOS_INTERPOLATION )
  add_subdirectory( interpolation )
  add_subdirectory( sandbox )
endif()

if( HAVE_LIBEMOS_BUFRDC )
  add_subdirectory( bufrdc_wmo )
endif()

if( ENABLE_INSTALL_TOOLS )
  add_subdirectory( tools )
endif()

if( HAVE_TESTS )
  add_subdirectory( tests )
endif()

#DEFINITIONS  FORTRAN_NO_UNDERSCORE

if( HAVE_LIBEMOS_GRIBEX )
  if( ${Fortran_COMPILER_NAME} MATCHES "ifort" OR CMAKE_Fortran_COMPILER_ID MATCHES "Intel" )
    set_source_files_properties( ${gribex_srcs} PROPERTIES COMPILE_FLAGS "-O0" )
  endif()
endif( HAVE_LIBEMOS_GRIBEX )


list( APPEND libemos_srcs
  ${emos_common_src_files}
  ${interpolation_srcs}
  ${gribex_srcs}
  ${bufrdc_wmo_srcs}
  ${pbio_srcs} )


################################################################################
# tables: BUFR and LSM interpolation

# should we install the old tables?
# probably only for new architectures
if( ENABLE_INSTALL_TABLES )
  install(
    DIRECTORY
      bufrtables
      gribtables
      gribtemplates
    DESTINATION ${INSTALL_DATA_DIR}/tables
    FILE_PERMISSIONS OWNER_READ GROUP_READ WORLD_READ )
endif()

### interpolation tables are always installed
if( NOT INTERPOL_TABLES_PATH )
  set( INTERPOL_TABLES_PATH "${INSTALL_DATA_DIR}/tables" )
endif()

# tables path to passed as PATH into compilation -D must be absolute
if( IS_ABSOLUTE "${INTERPOL_TABLES_PATH}" )
  set(emos_interpol_tables_def INTERPOL_TABLES_PATH="${INTERPOL_TABLES_PATH}" )
else()
  set(emos_interpol_tables_def INTERPOL_TABLES_PATH="${CMAKE_INSTALL_PREFIX}/${INTERPOL_TABLES_PATH}" )
endif()

message( STATUS "INTERPOL_TABLES_PATH: ${INTERPOL_TABLES_PATH}" )

# copy the tables/interpol to the build directory
file( COPY tables/interpol DESTINATION ${CMAKE_BINARY_DIR}/${INSTALL_DATA_DIR}/tables )

# always install tables/interpol
install( DIRECTORY tables/interpol DESTINATION "${INTERPOL_TABLES_PATH}" FILE_PERMISSIONS OWNER_READ GROUP_READ WORLD_READ )
install( CODE "execute_process(COMMAND \"${CMAKE_COMMAND}\" -E create_symlink interpol ${CMAKE_INSTALL_PREFIX}/${INSTALL_DATA_DIR}/tables/land_sea_mask)" )


################################################################################
# final definitions

list( APPEND LIBEMOS_DEFINITIONS
  ${emos_special_compiler_def}
  ${emos_special_system_def}
  REAL_8
  REAL_BIGGER_THAN_INTEGER
  POINTER_64
  _LARGEFILE64_SOURCE
  _FILE_OFFSET_BITS=64
  LITTLE_ENDIAN
  INTEGER_IS_INT
  ${GRIB_API_DEFINITIONS} )

# FIXME: LITTLE_ENDIAN is not portable!
# (EMOS-172: remove this flag, only used in GRIBEX, temporarily enabled for now)


################################################################################
# targets: libraries (single & douple p.) and version-check executable

set( LIBEMOS_BASE_DIR ${CMAKE_CURRENT_SOURCE_DIR} )

if( HAVE_SINGLE_PRECISION )
  add_subdirectory( libemos-sp )
endif()
add_subdirectory( libemos-dp )

if( CMAKE_Fortran_COMPILER_ID MATCHES "PGI" )
  set_source_files_properties( version.c PROPERTIES COMPILE_DEFINITIONS "FORTRAN_LINKER_PGI" )
  ecbuild_add_executable(
    TARGET      libemos_version
    DEFINITIONS ${LIBEMOS_DEFINITIONS}
    LIBS        emos
    SOURCES     version.c
    LINKER_LANGUAGE Fortran )
else()
  ecbuild_add_executable(
    TARGET      libemos_version
    DEFINITIONS ${LIBEMOS_DEFINITIONS}
    LIBS        emos
    SOURCES     version.c )
endif()

ecbuild_add_resources( TARGET libemos_rcs SOURCES_DONT_PACK compile.sh )


################################################################################
# finalize

ecbuild_pkgconfig(
  NAME        libemosR64
  URL         "https://software.ecmwf.int/wiki/display/EMOS/"
  DESCRIPTION "Interpolation library, including BUFR & CREX encoding/decoding routines"
  LANGUAGES   C FORTRAN
  LIBRARIES   emos )  # (double p. target)

if( HAVE_SINGLE_PRECISION )
  ecbuild_pkgconfig(
    NAME        libemos
    URL         "https://software.ecmwf.int/wiki/display/EMOS/"
    DESCRIPTION "Interpolation library, including BUFR & CREX encoding/decoding routines (single precision)"
    LANGUAGES   C FORTRAN
    LIBRARIES   emos_sp )  # (single p. target)
endif()

ecbuild_install_project( NAME libemos )
ecbuild_print_summary()

=== bufrtables/CMakeLists.txt ===
############################################################
# CMake options:
#
#   -DCMAKE_INSTALL_PREFIX="/usr/local/apps/libemos/tables/bufr/text/XXXYYY"  (optional: default is /usr/local )

cmake_minimum_required( VERSION 2.8.4 FATAL_ERROR )

project( bufrdc_tables C )

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")

set( ENABLE_OS_TESTS OFF )
set( ENABLE_OS_FUNCTIONS_TEST OFF )

include( ecbuild_system )

ecbuild_requires_macro_version( 1.7 )

###############################################################################
# project

ecbuild_declare_project()

math( EXPR TABLES_VERSION "100*${BUFRDC_TABLES_MAJOR_VERSION} + 10*${BUFRDC_TABLES_MINOR_VERSION} + ${BUFRDC_TABLES_PATCH_VERSION}") 
set( TABLES_VERSION "000${TABLES_VERSION}" )

file(GLOB links_txt RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.TXT )
file(GLOB distincts RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.distinct )

# debug
# message( STATUS "links_txt" ${links_txt} )
# message( STATUS "distincts" ${distincts} )

install( FILES ${distincts} DESTINATION ${INSTALL_DATA_DIR} )
install( FILES ${links_txt} DESTINATION ${INSTALL_DATA_DIR} )

message( STATUS "${PROJECT_NAME} version: ${TABLES_VERSION}" )
message( STATUS "${PROJECT_NAME} install to: ${CMAKE_INSTALL_PREFIX}/${INSTALL_DATA_DIR}" )

set( TEST_BUFR_TABLES_PATH "${PROJECT_SOURCE_DIR}" PARENT_SCOPE )

################################################################################
# finalize

ecbuild_install_project( NAME ${PROJECT_NAME} )

ecbuild_print_summary()

=== interpolation/CMakeLists.txt ===
list( APPEND interpolation_src_files

  current.h
  grdynam.h
  grfixed.h
  grspace.h
  intf.h
  intlog.h
  jparams.h
  memreq.h
  parim.h

  areachk.F
  auresol.F
  chequal.F
  chkout.F
  chkprec.F
  clear_c.F
  ddstyle.F
  dpath_tables_interpol.F90
  dssarea.F
  estima.F
  fft99.F
  fixarea.F
  forced_fftw.F
  forced_nearest_neighbour.F
  freecf.F
  funcs.F
  gasetup.F
  getconf.F
  gettru.F
  gghtype.F
  ggintrp.F
  gglonlat.F
  ggrotat.F
  ggvalue.F
  global.F
  hgengg.F
  hgengrd.F
  hgengrw.F
  hgenll.F
  hgetlsm.F
  hirlam.F
  hirlamw.F
  hirlsm.F
  hll2ll.F
  hll2llw.F
  hll2xyz.F
  hnei12.F
  hneill.F
  hntfap.F
  hntfaph.F
  hntfaps.F
  hntfau.F
  hntfauh.F
  hntfaus.F
  hpshgpw.F
  hrg2gg.F
  hrg2ggw.F
  hsh2gg.F
  hsp2gg.F
  hsp2gg2.F
  hsp2gg3.F
  hwts12.F
  hwtsll.F
  hwtslsm.F
  iafree.F
  iagcntl.F
  iainit.F
  iarcntl.F
  ibasini.F
  igalloc.F
  igbess.F
  igdins.F
  igdiwe.F
  igglat.F
  iggmem.F
  iggrid.F
  igint.F
  igintr.F
  iglgrid.F
  iglsize.F
  iglsm01.F
  iglsmb.F
  iglsmd.F
  iglsmr.F
  iglsmst.F
  ignorm.F
  igplsm.F
  igpoleg.F
  igpolew.F
  igprec.F
  igsetup.F
  igsize.F
  igtog.F
  insane.F
  intf.F
  intfap.F
  intfau.F
  intfb.F
  intfbu.F
  intin.F
  intisl.F
  intlog.F
  intlogd.F
  intlogr.F
  intocn.F
  intocnu.F
  intout.F
  intpnum.F
  intuvdh.F
  intuvgh.F
  intuvp.F
  intuvs.F
  intuvu.F
  intuvxh.F
  intuvy.F
  intvecy.F
  intwave2.F
  intwavu.F
  irdiwe.F
  irgmem.F
  irgrid.F
  irgtog.F
  irint.F
  irintr.F
  irlsmb.F
  irprec.F
  irsize.F
  is_wave_direction.F
  iscrsz.F
  isggvalid.F
  islproc.F
  isoctahedral.F
  issame.F
  issameiarray.F
  issamerarray.F
  jacobi.F
  jagggp.F
  jallgp.F
  jallwn.F
  jbess.F
  jdebug.F
  jfindfn.F
  jfindfn3.F
  jfindir.F
  jgetgg.F
  jgglat.F
  jjset99.F
  jmakgg.F
  jmakgg3.F
  jmakll.F
  jmakll3.F
  jmemhan.F
  jmemhan2.F
  jmkofgg.F
  jmovgg.F
  jmovll.F
  jmvugg.F
  jmvull.F
  jnorsgg.F
  jnumgg.F
  jopngg.F
  jopnggf.F
  jopnll.F
  jopnllf.F
  jreadgg.F
  jreadll.F
  jsgggp.F
  jsh2sh.F
  jsllgp.F
  jspleg1.F
  jsppole.F
  jstrll.F
  jstrwll.F
  jsymgg.F
  jsymll.F
  juvpole.F
  jvod2uv.F
  jwindll.F
  jwscal.F
  kintrg.F
  knfrom4.F
  krg2rg.F
  krg2rgd.F
  krg2rgu.F
  krg2rgy.F
  krg2rgz.F
  ll2xyz.F
  lsm_red.F
  lsmfld.F
  mkbitmp.F
  mkframe.F
  newisl.F
  ngintrp.F
  ngrotat.F
  ngvalue.F
  nmakgg.F
  nmakll.F
  numptns.F
  numptwe.F
  oceanp.F
  oceanu.F
  outrep.F
  pddefs.F
  precip.F
  qgoct.F
  qpassm.F
  reset_c.F
  rpassm.F
  rphi.F
  set99.F
  setrep.F
  sscal.F
  strlat.F
  w251idx.F
  waveidx.F
  wavexx2.F
  wv2didx.F
  wv2dint.F
  wv2dxx2.F
  wvqlidx.F
  wvqlint.F
  xyz2ll.F
  yrotate.F
  zprec.F

  emosPrecision.c
  fftchk.c
  gmapbit.c
  intlogs.c
  jchmod.c
  jindex.c
  jopnggsm.c
  jopnllsm.c
  makemap.c
  rename_unlink.c
  shareddt.c
  sharedgg.c
  sharedlib.c
  sharedll.c

  # (former grib_api_merging/)
  copy_spec_from_ksec.c
  describe_input_field.c
  emos.c
  emos.h
  intf2.c
  intuvp2.c
  intuvs2.c
  intvect2.c
)


foreach( src ${interpolation_src_files} )
  list( APPEND interpolation_srcs interpolation/${src} )
endforeach()

set( interpolation_srcs ${interpolation_srcs} PARENT_SCOPE )

=== tests/CMakeLists.txt ===

# set testing tools:
# - int (internal)
# - gg_gridname (internal)
# - grib_compare (bundle, on provided path, or on system path)
# - cmp (strict binary comparison)

if( ENABLE_INSTALL_TOOLS )
  get_target_property( CMD_INT         int         LOCATION )
  get_target_property( CMD_GG_GRIDNAME gg_gridname LOCATION )
endif()

if( TARGET grib_compare )
  get_target_property( CMD_GRIB_COMPARE grib_compare LOCATION )
endif()
if( NOT CMD_GRIB_COMPARE )
  find_program( CMD_GRIB_COMPARE grib_compare NO_DEFAULT_PATH HINTS "${grib_api_BASE_DIR}" PATH_SUFFIXES "bin" )
endif()
if( NOT CMD_GRIB_COMPARE )
  find_program( CMD_GRIB_COMPARE grib_compare )
endif()

find_program( CMD_CMP cmp )


# set testing environments (grib_api, libemos)
if( NOT grib_api_BASE_DIR AND CMD_GRIB_COMPARE )
  get_filename_component( _grib_compare_dir "${CMD_GRIB_COMPARE}" PATH )
  get_filename_component( grib_api_BASE_DIR "${_grib_compare_dir}" ABSOLUTE )
  set( grib_api_BASE_DIR "${grib_api_BASE_DIR}/../" )
endif()

if( grib_api_BASE_DIR )
  set( _grib_environment
    GRIB_DEFINITION_PATH=${grib_api_BASE_DIR}/share/grib_api/definitions/:${grib_api_BASE_DIR}/share/grib_api/definitions/grib1/
    GRIB_SAMPLES_PATH=${grib_api_BASE_DIR}/share/grib_api/samples/ )
endif()
set( _emos_environment
  "${_grib_environment}"
# JDCNDBG=2
# INTF2_DEBUG=1
  CONFIG_INTERP=ON_FLY
  MARS_LSM_PATH=${PROJECT_SOURCE_DIR}/tables/interpol
  ECMWF_LOCAL_TABLE_PATH=${PROJECT_SOURCE_DIR}/gribtables
  LOCAL_DEFINITION_TEMPLATES=${PROJECT_SOURCE_DIR}/gribtemplates )


# log information
ecbuild_info( "Test tool int:          ${CMD_INT}" )
ecbuild_info( "Test tool gg_gridname:  ${CMD_GG_GRIDNAME}" )
ecbuild_info( "Test tool grib_compare: ${CMD_GRIB_COMPARE}" )
ecbuild_info( "Test tool cmp:          ${CMD_CMP}" )
if( NOT CMD_INT OR NOT CMD_GG_GRIDNAME OR NOT CMD_GRIB_COMPARE OR NOT CMD_CMP )
  ecbuild_info( "(some tools not found, some tests disabled)" )
endif()
ecbuild_debug( "Test _grib_environment: ${_grib_environment}" )
ecbuild_debug( "Test _emos_environment: ${_emos_environment}" )


# configure Fortran-based targets for double precision (compilation & linking)
ecbuild_add_fortran_flags(${emos_double_precision_flags})


################ I N T E R P O L A T I O N ################

if( HAVE_LIBEMOS_INTERPOLATION )

  # intuvp2: interpolation to different formats
  foreach( rotated "" "rotated_" )
    foreach( out "regular_ll" "F80" "N80" "O80" )
      set( in "sh_vo-d" )
      set( test "${in}_to_${rotated}${out}" )
      set( rot "--rotation=30/30" )
      if( "${rotated}" STREQUAL "" )
        set( rot "" )
      endif()
      if(     NOT (test MATCHES "^sh_.*_to_O" AND NOT HAVE_FFTW)
          AND NOT (test MATCHES "^.*_to_rotated_[NOF]") )
        set( input  "${PROJECT_SOURCE_DIR}/data/${in}.grib" )
        set( output "intuvp2_${test}.grib" )
        if( out MATCHES "^regular_ll" )
          set( grid "--grid=3.0/3.0" )
        else()
          set( grid "--gridname=${out}" )
        endif()

        # interpolate
        ecbuild_add_test(
          TARGET       intuvp2_${test}_interpol
          DEPENDS      int
          COMMAND      ${CMD_INT}
          ARGS         ${grid} ${rot} --input=${input} --output=${output} --int=intuvp2
          ENVIRONMENT  ${_emos_environment} )

        # compare results to reference data
        ecbuild_add_test(
          TARGET       intuvp2_${test}_compare
          TEST_DEPENDS intuvp2_${test}_interpol
          CONDITION    CMD_GRIB_COMPARE
          COMMAND      ${CMD_GRIB_COMPARE}
          ARGS         ${PROJECT_SOURCE_DIR}/data/${output} ${output}
          ENVIRONMENT  ${_grib_environment} )

        unset( grid )
        unset( output )
        unset( input )
      endif()
      unset( rot )
      unset( test )
      unset( in )
    endforeach()
  endforeach()

  # intf2: interpolation to different formats
  # not possible:
  # - regular_ll to reduced Gaussian (G) (but regular_ll to regular G is possible)
  # - regular G to reduced G
  # - any to rotated reduced/regular G
  # - regular_ll to rotated regular_ll
  foreach( rotated "" "rotated_" )
    foreach( in "sh_vo-d" "sh_z" "regular_ll" "N640" "O640" "F640" )
      foreach( out "regular_ll" "F80" "N80" "O80" "F48" )
        set( test "${in}_to_${rotated}${out}" )
        set( rot "--rotation=30/30" )
        if( "${rotated}" STREQUAL "" )
          set( rot "" )
        endif()
        if(     NOT  test MATCHES "^regular_ll_to_[NO]"
            AND NOT  test MATCHES "^F.*_to_[NO]"
            AND NOT  test MATCHES "^.*_to_rotated_[NOF]"
            AND NOT  test MATCHES "^regular_ll_to_rotated_regular_ll$"
            AND NOT (test MATCHES "^sh_.*_to_O" AND NOT HAVE_FFTW) )
          set( input  "${PROJECT_SOURCE_DIR}/data/${in}.grib" )
          set( output "intf2_${test}.grib" )
          if( out MATCHES "^regular_ll" )
            set( grid "--grid=0.5/0.5" )
          else()
            set( grid "--gridname=${out}" )
          endif()

          # interpolate
          ecbuild_add_test(
            TARGET       intf2_${test}_interpol
            DEPENDS      int
            COMMAND      ${CMD_INT}
            ARGS         ${grid} --autoresol=1 --area=0/0/0/0 ${rot} --input=${input} --output=${output} --int=intf2
            ENVIRONMENT  ${_emos_environment} )

          # check gridname is expected and is a valid Gaussian grid
          if( out MATCHES "^[FNO]" )
            ecbuild_add_test(
              TARGET       intf2_${test}_gridname
              TEST_DEPENDS intf2_${test}_interpol
              CONDITION    CMD_GG_GRIDNAME
              COMMAND      ${CMD_GG_GRIDNAME}
              ARGS         --eq=${out} ${output}
              ENVIRONMENT  ${_grib_environment} )
          endif()

          # compare results to reference data, strict comparison except in some cases
          if( NOT CMD_CMP
              OR test MATCHES  "^regular_ll_to_regular_ll$"  # opensuse131/pgi, lxc/pgi
              OR test MATCHES  "^N640_to_O80$" )             # (minor numeric issues, within 2x packing error)
            ecbuild_add_test(
              TARGET       intf2_${test}_compare
              TEST_DEPENDS intf2_${test}_interpol
              CONDITION    CMD_GRIB_COMPARE
              COMMAND      ${CMD_GRIB_COMPARE}
              ARGS         -P -T 2 ${PROJECT_SOURCE_DIR}/data/${output} ${output}
              ENVIRONMENT  ${_grib_environment} )
          else()
            ecbuild_add_test(
              TARGET       intf2_${test}_compare
              TEST_DEPENDS intf2_${test}_interpol
              CONDITION    CMD_GRIB_COMPARE
              COMMAND      ${CMD_GRIB_COMPARE}
              ARGS         ${PROJECT_SOURCE_DIR}/data/${output} ${output}
              ENVIRONMENT  ${_grib_environment} )
          endif()

          unset( grid )
          unset( output )
          unset( input )
        endif()
        unset( rot )
        unset( test )
      endforeach()
    endforeach()
  endforeach()


  # intf2: interpolate to N/O grids with the same N
  # (distinguish between N640 <> O640)
  foreach( in "N640" "O640" )
    foreach( out "N640" "O640" )
      set( test "${in}_to_${out}" )
      set( input  "${PROJECT_SOURCE_DIR}/data/${in}.grib" )
      set( output "intf2_${test}.grib" )

      # interpolate
      ecbuild_add_test(
        TARGET       intf2_${test}_interpol
        DEPENDS      int
        COMMAND      ${CMD_INT}
        ARGS         --gridname=${out} --autoresol=1 --area=0/0/0/0 --input=${input} --output=${output} --int=intf2
        ENVIRONMENT  ${_emos_environment} )

      # compare results to reference data
      if( in STREQUAL out )
        ecbuild_add_test(
          TARGET       intf2_${test}_compare_same
          TEST_DEPENDS intf2_${test}_interpol
          CONDITION    CMD_GRIB_COMPARE
          COMMAND      ${CMD_GRIB_COMPARE}
          ARGS         ${input} ${output}
          ENVIRONMENT  ${_grib_environment} )
      else()
        ecbuild_add_test(
          TARGET       intf2_${test}_compare_diff
          TEST_DEPENDS intf2_${test}_interpol
          CONDITION    CMD_GRIB_COMPARE
          COMMAND      ${CMD_GRIB_COMPARE}
          ARGS         ${input} ${output}
          ENVIRONMENT  ${_grib_environment} )
        set_tests_properties( intf2_${test}_compare_diff PROPERTIES WILL_FAIL TRUE )
      endif()

      # expect a gridname
      ecbuild_add_test(
        TARGET       intf2_${test}_gridname
        TEST_DEPENDS intf2_${test}_interpol
        CONDITION    CMD_GG_GRIDNAME
        COMMAND      ${CMD_GG_GRIDNAME}
        ARGS         --eq=${out} ${output}
        ENVIRONMENT  ${_grib_environment} )

      unset( output )
      unset( input )
      unset( test )
    endforeach()
  endforeach()


  # intf2: interpolate to regular_ll corresponding to O1280 = 1/16 degree
  if( FALSE )
  foreach( in "O640" )
    set( test "${in}_to_regular_ll_1-16" )
    set( input  "${PROJECT_SOURCE_DIR}/data/${in}.grib" )
    set( output "intf2_${test}.grib" )

    # interpolate
    ecbuild_add_test(
      TARGET       intf2_${test}_interpol
      DEPENDS      int
      COMMAND      ${CMD_INT}
      ARGS         --grid=0.0625/0.0625 --input=${input} --output=${output} --int=intf2
      ENVIRONMENT  ${_emos_environment} )

    # compare results to reference data
    ecbuild_add_test(
      TARGET       intf2_${test}_compare
      TEST_DEPENDS intf2_${test}_interpol
      CONDITION    CMD_GRIB_COMPARE
      COMMAND      ${CMD_GRIB_COMPARE}
      ARGS         ${PROJECT_SOURCE_DIR}/data/${output} ${output}
      ENVIRONMENT  ${_grib_environment} )

    unset( output )
    unset( input )
    unset( test )
  endforeach()
  endif()


  # intf2: test GRIB edition 1 encoding limits
  # snap-milli-degree:     snaps to 0.001 because grid is 0.00025/0.00025, and is GRIB1-encodable
  # snap-sub-milli-degree: snaps to 0.0005, not GRIB1-encodable (failure expected)
  if( FALSE )
  foreach( snap "snap-milli-degree" "snap-sub-milli-degree_bad" )
    set( test "N640_to_regular_ll_${snap}" )
    if( snap MATCHES "^snap-milli-degree" )
      set( eps "0.00076" )
    elseif( snap MATCHES "^snap-sub-milli-degree" )
      set( eps "0.00074" )
    endif()
    ecbuild_add_test(
      TARGET       intf2_${test}_interpol
      DEPENDS      int
      COMMAND      ${CMD_INT}
      ARGS         --grid=0.00025/0.00025 --area=${eps}/0/0/${eps} --input=${PROJECT_SOURCE_DIR}/data/N640.grib --output="intf2_${test}.grib" --int=intf2
      ENVIRONMENT  ${_emos_environment} )
    unset( eps )
    unset( test )
  endforeach()
  set_tests_properties( intf2_N640_to_regular_ll_snap-sub-milli-degree_bad_interpol PROPERTIES WILL_FAIL TRUE )

  set( snap "snap-sub-milli-degree_sub-area_bad" )
  set( test "N640_to_regular_ll_${snap}" )
  ecbuild_add_test(
    TARGET       intf2_${test}_interpol
    DEPENDS      int
    COMMAND      ${CMD_INT}
    ARGS         --grid=0.0625/0.0625 --area=1/0.0625/0/0.5625 --input=${PROJECT_SOURCE_DIR}/data/N640.grib --output="intf2_${test}.grib" --int=intf2
    ENVIRONMENT  ${_emos_environment} )
  set_tests_properties( intf2_${test}_interpol PROPERTIES WILL_FAIL TRUE )
  unset( test )
  unset( snap )
  endif()


  # intf2: compare FFT99 vs FFTW exactly (no tolerance!)
  foreach( in "sh_vo-d" "sh_z" )
    set( output_fftw  "intf2_${in}_to_N80-fftw.grib" )
    set( output_fft99 "intf2_${in}_to_N80.grib" )

    # interpolate forcing FFTW
    ecbuild_add_test(
      TARGET       intf2_${in}_to_N80_fft99_vs_fftw_interpol_fftw
      TEST_DEPENDS intf2_${in}_to_N80_interpol
      DEPENDS      int
      COMMAND      ${CMD_INT}
      CONDITION    HAVE_FFTW
      ARGS         --gridname=N80 --autoresol=1 --area=0/0/0/0 --input=${PROJECT_SOURCE_DIR}/data/${in}.grib --output=${output_fftw} --int=intf2
      ENVIRONMENT  EMOSLIB_FORCED_FFTW=1 ${_emos_environment} )

    # compare results to already interpolated results (exactly)
    ecbuild_add_test(
      TARGET       intf2_${in}_to_N80_fft99_vs_fftw_compare

=== tools/CMakeLists.txt ===
# configure Fortran-based targets for double precision (compilation & linking)
ecbuild_add_fortran_flags(${emos_double_precision_flags})

if( HAVE_LIBEMOS_BUFRDC )
  add_subdirectory( bufrtools_wmo )
endif()

if( HAVE_LIBEMOS_INTERPOLATION )

  add_subdirectory( lsmReducedGaussian )

  if( NOT HAVE_GRIBEX_ABORT )
    add_subdirectory( singlePointInterpolation )
  endif()

  ecbuild_add_executable(
    TARGET      gg_latitudes NOINSTALL
    SOURCES     gg_latitudes.F
    DEFINITIONS ${LIBEMOS_DEFINITIONS}
    LIBS        emos )

  if( CMAKE_Fortran_COMPILER_ID MATCHES "PGI" )

    set_source_files_properties( gg_gridname.c PROPERTIES COMPILE_DEFINITIONS "FORTRAN_LINKER_PGI" )
    ecbuild_add_executable(
      TARGET      gg_gridname NOINSTALL
      SOURCES     gg_gridname.c
      DEFINITIONS ${LIBEMOS_DEFINITIONS}
      INCLUDES    ${GRIB_API_INCLUDE_DIRS}
      LIBS        emos
      LINKER_LANGUAGE Fortran )

    set_source_files_properties( gg_single.c PROPERTIES COMPILE_DEFINITIONS "FORTRAN_LINKER_PGI" )
    ecbuild_add_executable(
      TARGET      gg_single NOINSTALL
      SOURCES     gg_single.c
      DEFINITIONS ${LIBEMOS_DEFINITIONS}
      INCLUDES    ${GRIB_API_INCLUDE_DIRS}
      LIBS        emos
      LINKER_LANGUAGE Fortran )

  else()
    ecbuild_add_executable(
      TARGET      gg_gridname NOINSTALL
      SOURCES     gg_gridname.c
      DEFINITIONS ${LIBEMOS_DEFINITIONS}
      INCLUDES    ${GRIB_API_INCLUDE_DIRS}
      LIBS        emos )
    ecbuild_add_executable(
      TARGET      gg_single NOINSTALL
      SOURCES     gg_single.c
      DEFINITIONS ${LIBEMOS_DEFINITIONS}
      INCLUDES    ${GRIB_API_INCLUDE_DIRS}
      LIBS        emos )
  endif()

  ecbuild_add_executable(
    TARGET      int NOINSTALL
    SOURCES     int.F except.c
    DEFINITIONS ${LIBEMOS_DEFINITIONS}
    INCLUDES    ${GRIB_API_INCLUDE_DIRS}
    LIBS        emos )

endif()

=== tests/regress/CMakeLists.txt ===

######################### D A T A #########################

file(READ "download_tests_regress_src_files.txt" files)
string(REGEX REPLACE "\n" ";" files "${files}")
ecbuild_get_test_multidata( TARGET download_tests_regress_src_files NOCHECK NAMES ${files} )

file(READ "download_tests_regress_ref_files.txt" files)
string(REGEX REPLACE "\n" ";" files "${files}")
ecbuild_get_test_multidata( TARGET download_tests_regress_ref_files NOCHECK NAMES ${files} )


######################## EMOS-216 #########################

# tests with intuvp2
set( basen "regress_EMOS-216_intuvp2" )
foreach( area "" "_sub-area" )
  foreach( out "regular_ll" "F80" "N80" "O80" )
    set( in "vo-d_sh" )
    set( test "${basen}_${in}_to_${out}${area}" )
    set( input "${in}.grib" )
    set( output "${test}.grib" )
    if( NOT (test MATCHES "_sh_.+_to_O" AND NOT HAVE_FFTW) )
      unset( opt )
      if( out MATCHES "^regular_ll" )
        list( APPEND opt "--grid=3/3" )
      else()
        list( APPEND opt "--gridname=${out}" )
      endif()
      if( "${area}" STREQUAL "_sub-area" )
        list( APPEND opt "--area=70/-60/20/60" )
      endif()
  
      # interpolate
      ecbuild_add_test(
        TARGET       ${test}_interpol
        DEPENDS      int
        TEST_DEPENDS download_tests_regress_src_files
        COMMAND      ${CMD_INT}
        ARGS         --input=${input} --output=${output} ${opt} --int=intuvp2
        ENVIRONMENT  ${_emos_environment} )
  
      # compare results to reference data
      ecbuild_add_test(
        TARGET       ${test}_compare
        TEST_DEPENDS ${test}_interpol download_tests_regress_ref_files
        CONDITION    CMD_GRIB_COMPARE
        COMMAND      ${CMD_GRIB_COMPARE}
        ARGS         ${output}.ref ${output}
        ENVIRONMENT  ${_grib_environment} )

      unset( opt )
    endif()
    unset( output )
    unset( input )
    unset( test )
    unset( in )
  endforeach()
endforeach()
unset( basen )

# tests with intf2
# not possible:
# - regular_ll to reduced_gg (but regular_ll to regular_gg is possible)
# - regular_gg to reduced_gg
# - any to rotated reduced_gg/regular_gg
# - regular_ll to rotated regular_ll
# - ... weird HIRLAM restrictions?
# - any to octahedral without FFTW
# - swh_reduced_ll interpolations (SIGFPE, Arithmetic exception in INTIN) (FIXME: temporary disabling)
set( basen "regress_EMOS-216_intf2" )
foreach( area "" "_sub-area" )
  foreach( rotated "" "rotated_" "hirlam_non-rotated_" )
    foreach( in "2t_F640" "2t_F640_sub-area" "2t_N640" "2t_O1280" "2t_regular_ll" "2t_regular_ll_staggered" "2t_regular_ll_sub-area" "msl_F640" "msl_F640_sub-area" "msl_N640" "msl_O1280" "msl_regular_ll" "msl_regular_ll_sub-area" "swh_reduced_ll" "swh_reduced_ll_sub-area" "u-v_sh" "z_sh" )
      foreach( out "regular_ll" "F80" "N80" "O80" "F48" )
        set( test "${basen}_${in}_to_${rotated}${out}${area}" )
        set( input "${in}.grib" )
        set( output "${test}.grib" )
        if(     NOT (test MATCHES "_sub-area_to_" AND NOT test MATCHES "_to_.*_sub-area")
            AND NOT (test MATCHES "_regular_ll.*_to_[NO]")
            AND NOT (test MATCHES "_F.+_to_[NO]")
            AND NOT (test MATCHES "(F.+|reduced_ll)_to_.*rotated_regular_ll")
            AND NOT (test MATCHES "_to_[NO].*_sub-area")
            AND NOT (test MATCHES "_to_.*rotated_[NOF]")
            AND NOT (test MATCHES "_to_.*rotated_.*sub-area")
            AND NOT (test MATCHES "_regular_ll.*_to_.*rotated_regular_ll$")
            AND NOT (test MATCHES "_sh.*_to_O" AND NOT HAVE_FFTW)
            AND NOT (input MATCHES "swh_reduced_ll.*") ) #(FIXME)
          unset( opt )
          if( out MATCHES "^regular_ll" )
            list( APPEND opt "--grid=3/3" )
          else()
            list( APPEND opt "--gridname=${out}" )
          endif()
          if( "${rotated}" STREQUAL "hirlam_non-rotated_" )
            list( APPEND opt "--rotation=-90/0" )
          elseif( "${rotated}" STREQUAL "rotated_" )
            list( APPEND opt "--rotation=30/30" )
          endif()
          if( "${area}" STREQUAL "_sub-area" )
            list( APPEND opt "--area=70/-60/20/60" )
          endif()

          # interpolate
          ecbuild_add_test(
            TARGET       ${test}_interpol
            DEPENDS      int
            TEST_DEPENDS download_tests_regress_src_files
            COMMAND      ${CMD_INT}
            ARGS         --input=${input} --output=${output} ${opt} --int=intf2
            ENVIRONMENT  ${_emos_environment} )

          # compare results to reference data, strict comparison except in some cases
          if(    (test MATCHES "_F640_to_regular_ll")
              OR (test MATCHES "_N640_to_(regular_ll|O80|F80|F48)")
              OR (test MATCHES "_O1280_to_(regular_ll|N80)") )
            ecbuild_add_test(
              TARGET       ${test}_compare
              TEST_DEPENDS ${test}_interpol download_tests_regress_ref_files
              CONDITION    CMD_GRIB_COMPARE
              COMMAND      ${CMD_GRIB_COMPARE}
              ARGS         -P -T 2 ${output}.ref ${output}
              ENVIRONMENT  ${_grib_environment} )
          else()
            ecbuild_add_test(
              TARGET       ${test}_compare
              TEST_DEPENDS ${test}_interpol download_tests_regress_ref_files
              CONDITION    CMD_GRIB_COMPARE
              COMMAND      ${CMD_GRIB_COMPARE}
              ARGS         ${output}.ref ${output}
              ENVIRONMENT  ${_grib_environment} )
          endif()

          unset( opt )
        endif()
        unset( output )
        unset( input )
        unset( test )
      endforeach()
    endforeach()
  endforeach()
endforeach()
unset( basen )


###########################################################

=== tools/bufrtools_wmo/CMakeLists.txt ===

# configure Fortran-based targets for double precision (compilation & linking)
ecbuild_add_fortran_flags(${emos_double_precision_flags})


# if( CMAKE_Fortran_COMPILER_ID MATCHES "GNU" )
#   set_source_files_properties(
#     bufr_add_bias.F90
#     bufr_merg.F90
#     bufr_merge_tovs.F90
#     PROPERTIES COMPILE_FLAGS "-ffixed-form" )
# elseif( CMAKE_Fortran_COMPILER_ID MATCHES "Intel" )
#   set_source_files_properties(
#     bufr_add_bias.F90
#     bufr_merg.F90
#     bufr_merge_tovs.F90
#     PROPERTIES COMPILE_FLAGS "-fixed" )
# elseif( CMAKE_Fortran_COMPILER_ID MATCHES "Cray")
#   set_source_files_properties(
#     bufr_add_bias.F90
#     bufr_merg.F90
#     bufr_merge_tovs.F90
#     PROPERTIES COMPILE_FLAGS "-f fixed" )
# endif()


################################################################################
# sources

list( APPEND bufrtools_bins_F77
  bufr_0t2
  bufr_88t89
  bufr_check
  bufr_compress
  bufr_decode
  bufr_decode_all
  bufr_filter
  bufr_key
  bufr_nt1
  bufr_ntm
  bufr_obs_filter
  bufr_repack
  bufr_repack_206t205
  bufr_repack_satid
  bufr_ship_anmh
  bufr_ship_anmh_ERA
  bufr_split
  snow_key_repack )

list( APPEND bufrtools_bins_F90
  bufr_add_bias
  bufr_merg
  bufr_merge_tovs
  bufr_simulate )

list( APPEND bufrtools_bins_tracks
  tc_tracks
  tc_tracks_10t5
  tc_tracks_det
  tc_tracks_eps )


################################################################################
# F77

ecbuild_add_library(
  TARGET  my_exit NOINSTALL
  TYPE    STATIC
  SOURCES my_exit.F )

foreach( tool ${bufrtools_bins_F77} )
  ecbuild_add_executable(
    TARGET      ${tool}
    SOURCES     ${tool}.F
    DEFINITIONS ${LIBEMOS_DEFINITIONS}
    LIBS        my_exit emos )
endforeach()


################################################################################
# F90

if( ENABLE_FORTRAN90 )

  ecbuild_add_library(
    TARGET  bufr_module NOINSTALL
    TYPE    STATIC
    SOURCES mod_bufr.F90 )

  foreach( tool ${bufrtools_bins_F90} )
    ecbuild_add_executable(
      TARGET      ${tool}
      SOURCES     ${tool}.F90
      DEFINITIONS ${LIBEMOS_DEFINITIONS}
      LIBS        my_exit emos )
  endforeach()

  foreach( tool ${bufrtools_bins_tracks} )
    ecbuild_add_executable(
      TARGET      ${tool}
      SOURCES     ${tool}.F90
      CONDITION   HAVE_LIBEMOS_GRIBEX
      DEFINITIONS ${LIBEMOS_DEFINITIONS}
      LIBS        bufr_module my_exit emos )
  endforeach()

  ecbuild_add_executable(
      TARGET      grib2bufr
      SOURCES     grib2bufr.F90
      CONDITION   HAVE_LIBEMOS_GRIBEX
      DEFINITIONS ${LIBEMOS_DEFINITIONS}
      LIBS        my_exit emos )

endif( ENABLE_FORTRAN90 )

=== tools/lsmReducedGaussian/CMakeLists.txt ===

# configure Fortran-based targets for double precision (compilation & linking)
ecbuild_add_fortran_flags(${emos_double_precision_flags})

ecbuild_add_executable(
  TARGET  ginout_c2 NOINSTALL
  SOURCES ginout_c2.f90
  LIBS    emos )

=== debian/changelog ===
emoslib (2:4.3.7-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS on sparc64. Closes: #813649.
    - Set mcmodel=medany in debian/rules.
    - Add sparc64 to FPIC_LIST in debian/rules.
  * Remove trailing spaces in debian/changelog.
  * Wrap lines longer than 80 columns in debian/changelog.

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Mon, 08 Feb 2016 09:46:14 +0100

emoslib (2:4.3.7-1) unstable; urgency=medium

  * New upstream release.
  * Use -fPIC on m68k. Closes: #810389.
  * Standards-Version: 3.9.7. No changes required.
  * FFTW3 now required by EMOSLIB.
  * Set mcmodel=large for sparc64. Closes: #813649.
  * Ack, previously fixed symlink bug: Closes: #799854.

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 04 Feb 2016 13:04:39 +0000

emoslib (2:4.3.3-2) unstable; urgency=medium

  * Change libpng12-dev to libpng-dev for png16 transition. Closes: #810168.

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 07 Jan 2016 17:11:03 +0000

emoslib (2:4.3.3-1) unstable; urgency=medium

  * New upstream release.
    Provides new octahedral Gauss. grid support.
  * Refreshed patches. huge.patch, wvqlid2.patch no longer needed.

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 04 Jan 2016 03:39:28 +0000

emoslib (2:4.1.1-6) unstable; urgency=medium

  * Use -fPIC building on s390x to resolve GOT linking errors.
  * Link "--as-needed".

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 06 Nov 2015 19:12:20 +0000

emoslib (2:4.1.1-5) unstable; urgency=medium

  * Add s390x to the list of archs on which we disable tests.
  * Set INTERPOL_TABLES_PATH during build to be install location.
  * Set libemos-bin as MultiArch: allowed, with libemos-dev depend on
    libemos-bin:any
  * Fix interpol links in libemos-data to be relative.

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 28 Oct 2015 13:17:32 +0000

emoslib (2:4.1.1-4) unstable; urgency=medium

  * Disable tests for big-endian systems (being worked on upstream).

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 28 Oct 2015 03:05:01 +0000

emoslib (2:4.1.1-3) experimental; urgency=medium

  * Disable download of bufr tests.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 27 Oct 2015 16:06:30 +0000

emoslib (2:4.1.1-2) experimental; urgency=medium

  * Change /usr/lib/*/cmake/Emos -> /usr/lib/*/cmake/libemos
  * libemos-dev now depends on libemos-bin as cmake configs
    assume binaries are available.
  * Now need libboost-test-dev optional package.
  * Re-enable tests.
  * Fixup libemos-dev cmake files for metview to compile.

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 24 Oct 2015 20:58:07 +0100

emoslib (2:4.1.1-1) unstable; urgency=medium

  * New upstream release.

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 21 Oct 2015 12:38:35 +0100

=== debian/control ===
Source: emoslib
Section: utils
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper (>=9), gfortran, cmake, 
 libboost-dev (>= 1.47.0), libboost-test-dev, chrpath,
 libgrib-api-dev (>= 1.9.16~), libgrib-api-tools,
 libjasper-dev, libopenjpeg-dev, libpng-dev, zlib1g-dev,
 libfftw3-dev
Standards-Version: 3.9.7
Homepage: https://software.ecmwf.int/wiki/display/EMOS/Emoslib
Vcs-Git: git://anonscm.debian.org/debian-science/packages/emos.git

Package: libemos0d
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}, libemos-data
Pre-Depends: ${misc:Pre-Depends}
Description: ECMWF Interpolation Library
 The Interpolation library (EMOSLIB) includes Interpolation software and GRIB, 
 BUFR, CREX encoding/decoding routines. It is used by the ECMWF meteorological 
 archival and retrieval system (MARS) and also by the ECMWF graphics 
 package MetView.

Package: libemos-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libemos0d ( = ${binary:Version}), ${misc:Depends}, libemos-bin:any
Recommends: pkg-config
Description: ECMWF Interpolation Library - development
 The Interpolation library (EMOSLIB) includes Interpolation software and GRIB, 
 BUFR, CREX encoding/decoding routines. It is used by the ECMWF meteorological 
 archival and retrieval system (MARS) and also by the ECMWF graphics 
 package MetView.
 .
 This package contains the static libraries and headers needed to build 
 applications against libemos.

Package: libemos-bin
Section: libs
Architecture: any
Multi-Arch: allowed
Depends: ${misc:Depends}, ${shlibs:Depends}, libemos-data
Description: ECMWF Interpolation Library - binaries
 The Interpolation library (EMOSLIB) includes Interpolation software and GRIB,
 BUFR, CREX encoding/decoding routines. It is used by the ECMWF meteorological
 archival and retrieval system (MARS) and also by the ECMWF graphics
 package MetView.
 .
 This package provide bufr-* and other tools

Package: libemos-data
Architecture: any
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Data files for the ECMWF Interpolation library
 The Interpolation library (EMOSLIB) includes Interpolation software and GRIB, 
 BUFR, CREX encoding/decoding routines. It is used by the ECMWF meteorological 
 archival and retrieval system (MARS) and also by the ECMWF graphics 
 package MetView.
 .
 This package contains the data files needed by EMOSLIB.

=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE=1

# The magic debhelper  rule
%:
	dh $@ --buildsystem=cmake

export DEB_LDFLAGS_MAINT_PREPEND := -Wl,-z,defs -Wl,--as-needed

DESTDIR:=$(shell pwd)/debian/tmp
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
ARCH:=$(shell dpkg --print-architecture)
AUTOGENERATED:= libemos-dev.install libemos-dev.links libemos0d.install
LIBDIR:=/usr/lib/${DEB_HOST_MULTIARCH}
CMAKE_DIR:=debian/tmp/share/libemos/cmake
DO_TEST:=true

# Do tests on little-endian only for the moment;
BIGENDIAN_LIST:= "s390x mips sparc powerpc sparc64"
ifneq (,$(findstring $(ARCH),$(BIGENDIAN_LIST)))
  LITTLE:= false
else
  LITTLE:= true
endif

FPIC_LIST:= "s390x amd64 ppc64el m68k sparc64"
ifneq (,$(findstring $(ARCH),$(FPIC_LIST)))
  FPIC:= -fPIC
else
  FPIC:= -fpic
endif

MCMODEL_FLAGS:=''
BUILD_FLAGS:=''

ifeq ($(ARCH), amd64)
  MCMODEL_FLAGS:= -mcmodel=medium
endif
ifeq ($(ARCH), sparc64)
  MCMODEL_FLAGS:= -mcmodel=medany
endif
ifeq ($(ARCH), ppc64el)
  MCMODEL_FLAGS:= -mcmodel=large
endif
ifeq ($(ARCH), hurd-i386)
  BUILD_FLAGS:= ' -D__GNU__'
endif

override_dh_auto_test:
	# Need links for tests.
	(cd bufrtables && sh ./links.sh)
	 $(LITTLE) && dh_auto_test || echo "Tests disabled on bigendian systems for the moment"

override_dh_auto_clean:
	find bufrtables -type l -delete
	rm -f $(patsubst %, debian/%, ${AUTOGENERATED})
	dh_auto_clean

override_dh_auto_configure:
	dh_auto_configure -- \
		-DECBUILD_LOG_LEVEL=DEBUG \
		-DENABLE_FFTW=ON \
		-DENABLE_LITTLE_ENDIAN=$(LITTLE) \
		-DCMAKE_INSTALL_PREFIX=${DESTDIR} \
		-DCMAKE_BUILD_TYPE=Release \
		-DBUILD_SHARED_LIBS=ON \
		-DDISABLE_OS_CHECK=ON \
		-DMCMODEL_FLAGS=${MCMODEL_FLAGS} \
		-DBUILD_FLAGS=${BUILD_FLAGS} \
		-DFPIC=${FPIC} \
		-DINSTALL_LIBDIR=${LIBDIR} \
		-DINTERPOL_TABLES_PATH=/usr/share/emos \
		-DBUFR_TABLES_PATH=/usr/share/emos/bufrtables \
		-DTEST_BUFR_TABLES_PATH=${CURDIR}/bufrtables
	for f in ${AUTOGENERATED} ; do \
		sed -e 's%@ARCH@%${DEB_HOST_MULTIARCH}%g' < debian/$$f.in  > debian/$$f ; \
		done

override_dh_auto_build:
	dh_auto_build
	# Need to be installed into debian/tmp before tests
	cd obj-* && $(MAKE) install

# TODO: CHECK INTERPOL_TABLES_PATH is set correctly.		

override_dh_auto_install:
	cd obj-* && $(MAKE) install
	(cd ${DESTDIR}/share/libemos/tables/bufrtables && sh ./links.sh)
	dh_auto_install	
	# Fix broken paths 
	cat ${CMAKE_DIR}/libemos-targets-release.cmake | \
		sed -e 's%$${_IMPORT_PREFIX}/bin%/usr/bin%' | \
		sed -e 	's%$${_IMPORT_PREFIX}/lib%$(LIBDIR)%' > ${CMAKE_DIR}/tmp
	mv ${CMAKE_DIR}/tmp ${CMAKE_DIR}/libemos-targets-release.cmake
	# Change default from emos to emos_shared to link against shared libs in metview, etc.
	grep -v LIBEMOS_SELF_LIBRARIES ${CMAKE_DIR}/libemos-config.cmake > ${CMAKE_DIR}/tmp
	mv ${CMAKE_DIR}/tmp ${CMAKE_DIR}/libemos-config.cmake  
	echo "\nset( LIBEMOS_SELF_LIBRARIES    "emos_shared" )" >> ${CMAKE_DIR}/libemos-config.cmake
